import React, { Component, PropTypes } from 'react'
import Formsy from 'formsy-react'
import MuditaFormMixins from './mixins/MuditaFormMixins'
import {Checkbox as CheckboxBootstrap} from 'react-bootstrap'

const propUtilities = require('./propUtilities')

const Checkbox = React.createClass({
  mixins: [Formsy.Mixin, MuditaFormMixins],

  propTypes: {
    name: React.PropTypes.string.isRequired,
    options: React.PropTypes.array
  },

  changeValue: function(event) {
    let target = event.currentTarget;
    this.setValue(target.checked);
    this.props.onChange(this.props.name, target.checked);
  },

  changeCheckbox: function() {
    let value = [];
    this.props.options.forEach(function(option, key) {
      if (this['element-' + key].checked) {
        value.push(option.value);
      }

    }.bind(this));
    this.setValue(value);
    this.props.onChange(this.props.name, value);
  },

  renderElement: function() {
    if(this.props.options){
      const controls = this.props.options.map((checkbox, key) => {
        let checked = (this.getValue() ? this.getValue().indexOf(checkbox.value) !== -1 : false);
        let disabled = this.isFormDisabled() || checkbox.disabled || this.props.disabled;
        return (
          <CheckboxBootstrap
            ref={(c) => this['element-' + key] = c}
            checked={checked}
            value={checkbox.value}
            onChange={this.changeCheckbox}
            disabled={disabled}
            key={key}
            {...this.props.inline ? {inline: true} : {}}
          >
            {checkbox.label}
          </CheckboxBootstrap>

        );
      });
      return controls;
    }

    return (
      <CheckboxBootsrap
        ref={(c) => this.element = c}
        {...propUtilities.cleanProps(this.props)}
        onChange={this.changeValue}
        checked={this.getValue() === true}
      >
        {this.props.label}
      </CheckboxBootsrap>
    );
  },
  render: function() {
    let Layout = this.getLayout();
    return <Layout.Checkbox element={this} />;
  },
});

module.exports = Checkbox;
