import React, { Component, PropTypes } from 'react'
import Formsy from 'formsy-react';
import MuditaFormMixins from './mixins/MuditaFormMixins'
import {InputGroup,Button,FormControl} from 'react-bootstrap'

const propUtilities = require('./propUtilities')

const Input = React.createClass( {

  mixins: [Formsy.Mixin, MuditaFormMixins],

  propTypes: {
    type: React.PropTypes.oneOf([
      'color',
      'date',
      'datetime',
      'datetime-local',
      'email',
      'hidden',
      'month',
      'number',
      'password',
      'range',
      'search',
      'tel',
      'text',
      'time',
      'url',
      'week'
    ]),
    addonBefore: React.PropTypes.oneOfType([
      React.PropTypes.string,
      React.PropTypes.node
    ]),
    addonAfter: React.PropTypes.oneOfType([
      React.PropTypes.string,
      React.PropTypes.node
    ]),
    buttonBefore: React.PropTypes.node,
    buttonAfter: React.PropTypes.node
  },

  changeValue: function (event) {
    this.setValue(event.currentTarget.value);
  },

  renderElement: function (){
    return (
      <FormControl
        ref={(c) => this.element = c}
        className="form-control"
        {...propUtilities.cleanProps(this.props)}
        onChange={this.changeValue}
        value={this.getValue()}
        disabled={this.props.disabled}
      />
    );
  },

  renderInputGroup: function(element) {
    return (
      <InputGroup>
        {this.renderAddon(this.props.addonBefore)}
        {this.renderButton(this.props.buttonBefore)}
        {element}
        {this.renderAddon(this.props.addonAfter)}
        {this.renderButton(this.props.buttonAfter)}
      </InputGroup>
    );
  },

  renderAddon: function(addon) {
    if (!addon) {
      return false;
    }
    return (
      <InputGroup.Addon>{addon}</InputGroup.Addon>
    );
  },

  renderButton: function(button) {
    if (!button) {
      return false;
    }
    return (
      <InputGroup.Button><Button>{button}</Button></InputGroup.Button>
    );
  },

  render: function() {
    let Layout = this.getLayout();
    return (
      <Layout.Input element={this} />
    );
  }
});

module.exports = Input;
