import React, { Component, PropTypes } from 'react'
import Formsy from 'formsy-react'
import MuditaFormMixins from './mixins/MuditaFormMixins'

import { Radio } from 'react-bootstrap'


const RadioGroup  = React.createClass({

  mixins: [Formsy.Mixin, MuditaFormMixins],

  propTypes: {
    name: React.PropTypes.string.isRequired,
    options: React.PropTypes.array.isRequired
  },

  changeRadio: function(event) {
    var value = event.currentTarget.value;
    this.setValue(value);
    this.props.onChange(this.props.name, value);
  },

  renderElement: function() {
    const controls = this.props.options.map((radio, key) => {
      let checked = (this.getValue() === radio.value);
      let disabled = this.isFormDisabled() || radio.disabled || this.props.disabled;

      return (
        <Radio
          inputRef={(c) => this['element-' + key] = c}
          key={key}
          checked={checked}
          value={radio.value}
          onChange={this.changeRadio}
          disabled={disabled}
          {...this.props.inline ? {inline: true} : {}}
        >
          {radio.label}
        </Radio>
      );
    });
    return controls;
  },


  render: function() {
    let Layout = this.getLayout();
    return <Layout.RadioGroup element={this} />;
  }

});

module.exports = RadioGroup;
