import React, { Component, PropTypes } from 'react'
import Formsy from 'formsy-react'
import MuditaFormMixins from './mixins/MuditaFormMixins'

import { FormGroup, FormControl } from 'react-bootstrap';

/*
@Todo : Gérer les groups
*/

const Select = React.createClass({

  mixins: [Formsy.Mixin, MuditaFormMixins],

  changeValue: function(event) {
    let value;
    let target = event.currentTarget;
    if (this.props.multiple) {
      value = [];
      for (var i = 0; i < target.length; i++){
        var option = target.options[i];
        if (option.selected) {
          value.push(option.value);
        }
      }
    } else {
      value = target.value;
    }
    this.setValue(value);
    this.props.onChange(this.props.name, value);
  },

  renderElement: function() {

    let renderOption = function(item, key) {
      const { group, label, ...rest } = item;
      return (
        <option key={key} {...rest}>{item.label}</option>
      )};

      let options = this.props.options;

      let optionNodes = [];

      optionNodes = options.map(function (item, index) {
        return renderOption(item, index);
      });

      return (
        <FormControl
          ref={(c) => this.element = c}
          onChange={this.changeValue}
          componentClass="select"
          value={this.getValue()}
          multiple={this.props.multiple ? "multiple" : ''}
        >
          {optionNodes}
        </FormControl>
      );
    },
    render: function() {
      let Layout = this.getLayout();
      return <Layout.Select element={this} />;
    },
  });

  module.exports = Select;
