
import React, { Component, PropTypes } from 'react'
import Layout from 'muditaform-horizontal';

module.exports = {

  propTypes: {
    // Un layout doit apparaitre ici pour fonctionner
    layout: React.PropTypes.objectOf(React.PropTypes.element),
    labelClassName: React.PropTypes.oneOfType([
      React.PropTypes.string,
      React.PropTypes.array,
      React.PropTypes.object
    ])
  },

  contextTypes: {
    layout: React.PropTypes.object,
    labelClassName: React.PropTypes.oneOfType([
      React.PropTypes.string,
      React.PropTypes.array,
      React.PropTypes.object
    ])
  },
  getDefaultProps: function() {
        return {
            disabled: false,
            onChange: function() {},
            onFocus: function() {},
            onBlur: function() {}
        };
    },

  getLayout: function() {
    var defaultProperty = this.context.layout || 'horizontal';
    return this.props.layout ? this.props.layout : defaultProperty;
  },

  getLabelClassName: function() {
    return this.context.labelClassName ? this.context.labelClassName : this.props.labelClassName ? this.props.labelClassName : '';
  },

  getValidationState: function() {
    return this.isPristine() ? '' : this.isValid() ? 'success' : this.showError() ? 'error' : undefined;

  }

};
